#ifndef SOCKET_H

#define SOCKET_H

#include <netinet/in.h>
#include "stock.h"

req_t ok, err;

/* socket.h has macros for sock_read_int and friends and function
 * declararions for socket.c 
 */

#define sw(socket, buf, cnt) sock_write (socket, buf, cnt)

#define sr(socket, buf, cnt) sock_read (socket, buf, cnt)

#define sr_int(socket, a)     sock_read (socket, & ## a, sizeof(int32_t)); \
                              a = ntohl(a)

#define sr_s_int(socket, a)   sock_read (socket, & ## a, sizeof(int16_t)); \
                              a = ntohs(a)

#define sr_char(socket, a)    sock_read (socket, & ## a, sizeof(char))

#define sw_char(socket, a)    sock_write (socket, & ## a, sizeof(char))

#define SEND_OK               sw_char (server, ok)
#define SEND_ERR              sw_char (server, err)

#define RECV_OK               sr_char (server, ok_r);
#define RECV_OK2              sr_char (server2, ok_r);

/* We have to use htonl() and ntohl() and friends cause the
 * byte ordering is the other way round on i80x86 and probably some 
 * others too... can't help the extra clocks, cause the CPUs are 
 * quite cheap :) 
 */

#define sr_plid(plid)     sr_int (server, plid)
#define sr_plid2(plid)    sr_int (server2, plid)
#define sw_plid(plid)     sw_int (server, plid)

#define sr_qty(qty)       sr_int (server, qty)
#define sr_qty2(qty)      sr_int (server2, qty)
#define sw_qty(qty)       sw_int (server, qty)

#define sr_pr(pr)         sr_int (server, pr)
#define sr_pr2(pr)        sr_int (server2, pr)
#define sw_pr(pr)         sw_int (server, pr)

#define sr_cid(cid)       sr_int (server, cid)
#define sr_cid2(cid)      sr_int (server2, cid)
#define sw_cid(cid)       sw_int (server, cid)

#define sr_req(req)       sr_char (server, req)
#define sr_req2(req)      sr_char (server2, req)
#define sw_req(req)       sw_char (server, req)

#define sr_passwd(passwd)   sr_int (server, passwd)
#define sr_passwd2(passwd)  sr_int (server2, passwd)
#define sw_passwd(passwd)   sw_int (server, passwd)

#endif /* SOCKET_H */
